// first program to test the arm 9 on the comstick using gcc.
// There is an LED on the board that can be flashed by flipping P9.0
//mww 0x5800F004 1 ON
//mww 0x5800F004 0 OFF
#include "str912fw44.h"
void TIMER0_ISR(void) __attribute__ ((interrupt("IRQ")));
void default_IRQ_ISR0(void) __attribute__ ((interrupt("IRQ")));
void global_interrupt_enable(void);
void configure_gpio_ports(void);
void configure_timer(void);
void configure_vic(void);
void configure_interrupts(void);
int Temp;
void global_interrupt_enable(void) {
// enables IRQ but disables FIQ    
  asm(" \
  MRS r0, cpsr    \n \
  ORR r0, r0, #0x00000040 \n \
  AND r0, r0, #0xffffff7f   \n \
  MSR cpsr_c, r0 \n \
  ");
    
}

void default_IRQ_ISR0() {           
	// handles spurious interrupts - need to look into acknowledgement.
        VIC0_VAR = 0;		 // ack VIC     
}

void TIMER0_ISR() {
	P9LSB ^=1; // toggle LSB
//	Ack interrupt	
	TIM_SR = 0;
	VIC0_VAR  = 0;
}
void configure_gpio_ports() {
// turn on clock for GPIO port 9
	SCU_PCGR1 |= BIT23;
// take port out of reset
	SCU_PRR1 |= BIT23;
// make LSB an output
	P9DIR  = 1; 
}
void configure_vic() {
// turn on clock for VIC
	SCU_PCGR0 |= BIT5;
// take VIC out of reset
	SCU_PRR0 |= BIT5;
// ack any pending interrupt
	VIC0_INTECR = 0xffffffff;
	VIC0_SWINTCR = 0xffffffff;
	VIC0_VAR  = 0;	

}
void configure_interrupts(){
// turn on and configure the VIC
// Timer 0's interrupt vector is in slot/channel 4 of VIC 0
// 
// so need to put address of ISR in VIC0_VA4R 
	configure_vic();
// set the interrupt vector in the VIC
	VIC0_VC4R = 4;
	VIC0_VA4R = (int)TIMER0_ISR;
	//VIC0_DVAR = (int)TIMER0_ISR;
// set the default vector address in the VIC
	VIC0_DVAR = (int)default_IRQ_ISR0;	
// IRQ interrupts only
	VIC0_INTSR = 0;	
// enable the interrupt (Part 1)
	VIC0_INTER |= BIT4;
// enable the interrupt (Part 2)
	VIC0_VC4R |= BIT5;
}
void configure_timer() {
// turn on clock to timer 0/1
	SCU_PCGR1 |= BIT0;
// take timer 0/1 out of reset
	SCU_PRR1 |= BIT0;
// clear any interrupts that may be pending
	TIM_SR = 0;
// finally enable the timer	
	TIM_CR1	|= BIT15;
// adjust the divisor
	TIM_CR2 |= 0xff; // divide by 256
// enable the timer overflow interrupt
	TIM_CR2 |= BIT13; 
}
int main() {
	configure_gpio_ports();
	configure_timer();
	configure_interrupts();
	global_interrupt_enable();
	while(1) {  		
		NOP();		
	}
	return 0;
}
